<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <title>Document</title>
</head>

<body onload="onPageLoading()">
    <div class="jumbotron text-center">
        <h3 style="margin-bottom: 2rem;">THÔNG TIN LIÊN HỆ CHI TIẾT</h3>

        <form action="" id="contact-form">
            <div class="row form-group">
                <label class="col-md-3 col-form-label text-right">Name <span class="text-danger">(*)</span></label>
                <div class="col-md-7">
                    <input id="input-name" class="form-control"></input>
                </div>
            </div>

            <div class="row form-group">
                <label class="col-md-3 col-form-label text-right">Email <span class="text-danger">(*)</span></label>
                <div class="col-md-7">
                    <input id="input-email" class="form-control"></input>
                </div>
            </div>

            <div class="row form-group">
                <label class="col-md-3 col-form-label text-right">Message <span class="text-danger">(*)</span></label>
                <div class="col-md-7">
                    <textarea id="input-message" class="form-control"></textarea>
                </div>
            </div>

            <div class="row form-group">
                <label class="col-md-3 col-form-label text-right">Ngày liên hệ <span
                        class="text-danger">(*)</span></label>
                <div class="col-md-7">
                    <input id="input-ngay-lien-he" class="form-control"></input>
                </div>
            </div>

            <div class="row">
                <div class="col-md-3"></div>
                <div class="col-md-7 text-right">
                    <button style="margin-top: 1rem;" class="btn btn-success">
                        Save data
                    </button>
                </div>
            </div>
        </form>
    </div>
</body>

<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    var gId = "";
    var gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm thực thi khi tải trang
    function onPageLoading() {
        var vQueryObj = {
            id: "",
        };
        //B1: lấy dữ liệu từ trang web trước
        thuThapDuLieu(vQueryObj);

        //B2: kiểm tra dữ liệu
        var vCheck = kiemtraDuLieu(vQueryObj);
        if (vCheck) {
            //B3: gọi api lấy chi tiết 01 contact by id
            var vXHTMLRequest = new XMLHttpRequest();
            goiApiGetContact(vXHTMLRequest, vQueryObj);
            vXHTMLRequest.onreadystatechange = function () {
                if (
                    this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
                    this.status == gREQUEST_STATUS_OK
                ) {
                    console.log(vXHTMLRequest.responseText);
                    //B4: hiển thị dữ liệu
                    var bContactObj = JSON.parse(vXHTMLRequest.responseText);
                    hienThiDuLieu(bContactObj);
                }
            };
        } else {
            history.back();
        }
    }

    var loginForm = document.getElementById("contact-form");
    loginForm.addEventListener("submit", (e) => {
        // Sử dụng preventDefault để loại bỏ hành động submit mặc định của form
        e.preventDefault();
        // Bước 0: Khởi tạo đối tượng thu thập
        var vObject = {
            name: "",
            email: "",
            message: "",
            ngayLienHe: ""
        };
        // Bước 1: thu thập dữ liệu
        getDataFromInputUpdate(vObject);
        // Bước 2: Kiểm tra dữ liệu thu thập
        var vCheck = validateDataUpdate(vObject);
        if (vCheck) {
            // create a request
            var vXmlHttpUpdate = new XMLHttpRequest();
            //Bước 3: gọi api để update contact theo id
            processAPIUpdate(vXmlHttpUpdate, vObject);
            vXmlHttpUpdate.onreadystatechange = function () {
                if (
                    this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK
                ) {
                    var bUpdateRespond = vXmlHttpUpdate.responseText;
                    console.log(vXmlHttpUpdate.responseText);
                    alert("Sửa thành công");
                    window.location.href = "listContact.html";
                }
            };
        }
    });

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm thu thập dữ liệu
    function thuThapDuLieu(paramQueryObj) {
        var vUrlString = window.location.href; //đường đẫn gọi đến trang

        //tạo đối tượng url để truy vấn tham số
        var vUrlObject = new URL(vUrlString);
        //get a parameter
        gId = vUrlObject.searchParams.get("id");
        paramQueryObj.id = gId;

        console.log(paramQueryObj);
    }

    //hàm kiểm tra dữ liệu
    function kiemtraDuLieu(paramQueryObj) {
        if (paramQueryObj.id == null) {
            alert("Lỗi id");
            return false;
        }

        return true;
    }

    //hàm gọi api get contact by id
    function goiApiGetContact(paramXHTMLRequest, paramQueryObj) {
        const vAPI_URL = gBASE_URL + "contacts/";

        paramXHTMLRequest.open("GET", vAPI_URL + paramQueryObj.id, true);
        paramXHTMLRequest.send();
    }

    //hàm hiển thị dữ liệu
    function hienThiDuLieu(paramContactObj) {
        var vNameInput = document.getElementById("input-name");
        var vEmailInput = document.getElementById("input-email");
        var vMessageInput = document.getElementById("input-message");
        var vNgayLienHeInput = document.getElementById("input-ngay-lien-he");

        vNameInput.value = paramContactObj.name;
        vEmailInput.value = paramContactObj.email;
        vMessageInput.value = paramContactObj.message;
        vNgayLienHeInput.value = paramContactObj.createDate;
    }

    // Hàm thu thập dữ liệu
    function getDataFromInputUpdate(paramObject) {
        "use strict";
        var vNameInput = document.getElementById("input-name");
        var vEmailInput = document.getElementById("input-email");
        var vMessageInput = document.getElementById("input-message");
        var vNgayLienHeInput = document.getElementById("input-ngay-lien-he");

        paramObject.name = vNameInput.value.trim();
        paramObject.email = vEmailInput.value.trim();
        paramObject.message = vMessageInput.value.trim();
        paramObject.ngayLienHe = vNgayLienHeInput.value.trim();
    }

    // Hàm kiểm tra dữ liệu thu thập
    // Input là đối tượng dữ liệu cần kiểm tra
    // Output là kết quả true / false
    function validateDataUpdate(paramObject) {
        "use strict";

        if (paramObject.name == "") {
            alert("Bạn cần nhập name!");
            return false;
        }

        if (paramObject.email == "") {
            alert("Bạn cần nhập email!");
            return false;
        }
        if (validateEmail(paramObject.email) == false) {
            alert("Email không đúng định dạng!");
            return false;
        }

        if (paramObject.message == "") {
            alert("Bạn cần nhập message!");
            return false;
        }
        if (paramObject.message.length <= 20) {
            alert("Message phải có độ dài trên 20 ký tự!");
            return false;
        }

        if (paramObject.ngayLienHe == "") {
            alert("Bạn cần nhập ngày liên hệ!");
            return false;
        }

        return true;
    }

    // Hàm kiểm tra email
    // Input là email cần kiểm tra
    // Output là true / false
    function validateEmail(mail) {
        if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(mail)) {
            return true;
        }
        return false;
    }

    //Hàm gọi api để update contact theo id
    function processAPIUpdate(paramXmlHttpUpdate, paramObject) {
        const vAPI_URL = gBASE_URL + "contacts/";

        paramXmlHttpUpdate.open("PUT", vAPI_URL + gId, true);
        paramXmlHttpUpdate.setRequestHeader("Content-Type", "application/json");
        paramXmlHttpUpdate.send(JSON.stringify(paramObject));
    }
</script>

</html>